## deepin-kwin 6.0.8

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.13)

set(DVERSION "5.27.2" CACHE STRING "define project version")
project(KWin VERSION ${DVERSION})

set(CMAKE_C_STANDARD 99)
set(CMAKE_CXX_STANDARD 20)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

if (NOT DEFINED BUILD_ON_V25)
    find_package(QT NAMES Qt6 QUIET)
    if(NOT QT_FOUND)
        message(STATUS "Not found qt6, will build with v20 interface")
        set(BUILD_ON_V25 OFF)
        find_package(QT NAMES Qt5 REQUIRED)
    else()
        message(STATUS "Has found qt6, will build with v25 interface")
        set(BUILD_ON_V25 ON)
    endif()
else()
    message(STATUS "Build On v25: \"${BUILD_ON_V25}\"")
endif()

option(BUILD_TESTING "Build the testing tree" OFF)

if (BUILD_ON_V25)
  set(QT_MAJOR_VERSION "6")
  set(KF_MAJOR_VERSION "6")
  set(QT_MIN_VERSION "6.0.0")
  set(KF_MIN_VERSION "6.0.0")
  set(KF_CURRENT_VERSION "6.0.0")
else()
  set(QT_MAJOR_VERSION "5")
  set(KF_MAJOR_VERSION "5")
  set(QT_MIN_VERSION "5.11.3")
  set(KF_MIN_VERSION "5.54.0")
  set(KF_CURRENT_VERSION "5.102.0")
endif()

set(KDE_COMPILERSETTINGS_LEVEL "5.54")

if(MEMCHECK)
    set(CMAKE_BUILD_TYPE Debug)
    set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -O1 -fno-omit-frame-pointer -Wall -Wextra -fsanitize=address")
    set(CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} -O1 -fno-omit-frame-pointer -Wall -Wextra -fsanitize=address")
    set(CMAKE_LINKER_FLAGS_DEBUG "${CMAKE_LINKER_FLAGS_DEBUG} -fsanitize=address")
    set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -fsanitize=address")
endif()

find_package(ECM "${KF_CURRENT_VERSION}" REQUIRED NO_MODULE)

# where to look first for cmake modules, before ${CMAKE_ROOT}/Modules/ is checked
set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules ${ECM_MODULE_PATH})

include(CMakeDependentOption)
include(CMakePackageConfigHelpers)
include(FeatureSummary)
include(WriteBasicConfigVersionFile)
include(GenerateExportHeader)
include(CheckCXXCompilerFlag)
include(CheckIncludeFile)
include(CheckIncludeFiles)
include(CheckSymbolExists)

include(KDEInstallDirs)
include(KDECMakeSettings)
include(KDECompilerSettings NO_POLICY_SCOPE)
include(KDEClangFormat)
include(KDEGitCommitHooks)

include(ECMFindQmlModule)
include(ECMInstallIcons)
include(ECMOptionalAddSubdirectory)
include(ECMConfiguredInstall)
include(ECMQtDeclareLoggingCategory)

find_package(Qt${QT_MAJOR_VERSION} REQUIRED COMPONENTS
    Concurrent
    Core
    DBus
    Quick
    Svg
    UiTools
    Widgets
    LinguistTools
)

if (QT_MAJOR_VERSION EQUAL "5")
    find_package(Qt5 ${QT_MIN_VERSION} CONFIG REQUIRED COMPONENTS X11Extras)
    find_package(Qt5XkbCommonSupport REQUIRED)
    set(LUPDATE_EXECUTABLE "lupdate")
    set(LRELEASE_EXECUTABLE "lrelease")
else()
    find_package(Qt6 ${QT_MIN_VERSION} CONFIG REQUIRED COMPONENTS WaylandClient ShaderTools)
    if (Qt6WaylandClient_VERSION VERSION_LESS "6.4.1") # TODO Plasma 6: Drop once minimum Qt version is 6.4.1+
        include(Qt6WaylandClientMacrosKde)
    endif()
    get_target_property(LRELEASE_EXECUTABLE Qt6::lrelease IMPORTED_LOCATION)
    get_target_property(LUPDATE_EXECUTABLE Qt6::lupdate IMPORTED_LOCATION)
endif()

# required frameworks by Core
find_package(KF${KF_MAJOR_VERSION} ${KF_MIN_VERSION} REQUIRED COMPONENTS
    Auth
    Config
    ConfigWidgets
    CoreAddons
    Crash
    DBusAddons
    GlobalAccel
    I18n
    IdleTime
    Package
    WidgetsAddons
    WindowSystem
)

if (KF_MAJOR_VERSION EQUAL "5")
  find_package(KF5 REQUIRED COMPONENTS Plasma)
endif()

# required frameworks by config modules
find_package(KF${KF_MAJOR_VERSION} ${KF_MIN_VERSION} REQUIRED COMPONENTS
    Declarative
    KCMUtils
    NewStuff
    Service
    XmlGui
    ItemViews
)

find_package(Threads)
set_package_properties(Threads PROPERTIES
    PURPOSE "Needed for VirtualTerminal support in KWin Wayland"
    TYPE REQUIRED
)

if (KF_MAJOR_VERSION EQUAL "5")
    find_package(KF5Wayland ${KF5_MIN_VERSION} CONFIG)
    set_package_properties(KF5Wayland PROPERTIES
        PURPOSE "Required to build wayland platform plugin and tests"
        TYPE REQUIRED
    )
else()
    find_package(KWayland ${KF_MIN_VERSION} CONFIG)
    set_package_properties(KWayland PROPERTIES
        PURPOSE "Required to build wayland platform plugin and tests"
        TYPE REQUIRED
    )
endif()

# optional frameworks
find_package(KF${KF_MAJOR_VERSION}Activities ${KF_MIN_VERSION} CONFIG)
set_package_properties(KF${KF_MAJOR_VERSION}Activities PROPERTIES
    PURPOSE "Enable building of KWin with kactivities support"
    TYPE OPTIONAL
)
add_feature_info("KF${KF_MAJOR_VERSION}Activities" KF${KF_MAJOR_VERSION}Activities_FOUND "Enable building of KWin with kactivities support")

find_package(KF${KF_MAJOR_VERSION}DocTools ${KF_MIN_VERSION} CONFIG)
set_package_properties(KF${KF_MAJOR_VERSION}DocTools PROPERTIES
    PURPOSE "Enable building documentation"
    TYPE OPTIONAL
)
add_feature_info("KF${KF_MAJOR_VERSION}DocTools" KF${KF_MAJOR_VERSION}DocTools_FOUND "Enable building documentation")

find_package(KF${KF_MAJOR_VERSION}Runner ${KF_MIN_VERSION} CONFIG)
set_package_properties(KF${KF_MAJOR_VERSION}Runner PROPERTIES
    PURPOSE "Enable building of KWin with krunner support"
    TYPE OPTIONAL
    )
add_feature_info("KF${KF_MAJOR_VERSION}Runner" KF${KF_MAJOR_VERSION}Runner_FOUND "Enable building of KWin with krunner support")

find_package(KF${KF_MAJOR_VERSION}Kirigami2 ${KF_MIN_VERSION} CONFIG)
set_package_properties(KF${KF_MAJOR_VERSION}Kirigami2 PROPERTIES
    DESCRIPTION "A QtQuick based components set"
    PURPOSE "Required at runtime for Virtual desktop KCM"
    TYPE RUNTIME
)

if (BUILD_ON_V25)
    add_definitions(-DBUILD_ON_V25)
    add_definitions(-DBUILD_WITHOUT_V20_PATCH)
    add_subdirectory(kdecoration)
else()
  find_package(KDecoration2 ${PROJECT_VERSION} CONFIG)
  set_package_properties(KDecoration2 PROPERTIES
      TYPE REQUIRED
      PURPOSE "Required for server side decoration support"
  )
endif()

find_package(KF${KF_MAJOR_VERSION}KCMUtils ${PROJECT_VERSION} CONFIG)
find_package(KF${KF_MAJOR_VERSION}Service ${PROJECT_VERSION} CONFIG)


# find_package(Breeze 6.0.0 CONFIG)
# set_package_properties(Breeze PROPERTIES
#     TYPE OPTIONAL
#     PURPOSE "For setting the default window decoration plugin"
# )
# if (${Breeze_FOUND})
#     if (${BREEZE_WITH_KDECORATION})
#         set(HAVE_BREEZE_DECO true)
#     else()
#         set(HAVE_BREEZE_DECO FALSE)
#     endif()
# else()
#     set(HAVE_BREEZE_DECO FALSE)
# endif()
# add_feature_info("Breeze-Decoration" HAVE_BREEZE_DECO "Default decoration plugin Breeze")
set(HAVE_BREEZE_DECO FALSE)

find_package(EGL)
set_package_properties(EGL PROPERTIES
    TYPE REQUIRED
    PURPOSE "Required to build KWin with EGL support"
)

find_package(epoxy 1.3)
set_package_properties(epoxy PROPERTIES
    DESCRIPTION "libepoxy"
    URL "https://github.com/anholt/libepoxy"
    TYPE REQUIRED
    PURPOSE "OpenGL dispatch library"
)

set(HAVE_DL_LIBRARY FALSE)
if (epoxy_HAS_GLX)
    find_library(DL_LIBRARY dl)
    if (DL_LIBRARY)
        set(HAVE_DL_LIBRARY TRUE)
    endif()
endif()

check_cxx_source_compiles("
#include <fcntl.h>
#include <sys/mman.h>
#include <unistd.h>

int main() {
    const int size = 10;
    int fd = memfd_create(\"test\", MFD_CLOEXEC | MFD_ALLOW_SEALING);
    ftruncate(fd, size);
    fcntl(fd, F_ADD_SEALS, F_SEAL_SHRINK | F_SEAL_GROW | F_SEAL_WRITE | F_SEAL_SEAL);
    mmap(nullptr, size, PROT_WRITE, MAP_SHARED, fd, 0);
}" HAVE_MEMFD)

find_package(Wayland 1.21)
set_package_properties(Wayland PROPERTIES
    TYPE REQUIRED
    PURPOSE "Required for building KWin with Wayland support"
)

find_package(WaylandProtocols 1.31)
set_package_properties(WaylandProtocols PROPERTIES
    TYPE REQUIRED
    PURPOSE "Collection of Wayland protocols that add functionality not available in the Wayland core protocol"
    URL "https://gitlab.freedesktop.org/wayland/wayland-protocols/"
)

if(BUILD_ON_V25)
    find_package(DeepinWaylandProtocols 1.9.0 CONFIG)
    set_package_properties(DeepinWaylandProtocols PROPERTIES
        TYPE REQUIRED
        PURPOSE "Collection of Deepin-specific Wayland protocols"
        URL "https://github.com/linuxdeepin/deepin-wayland-protocols/"
    )
    set(PLASMA_WAYLAND_PROTOCOLS_DIR ${DEEPIN_WAYLAND_PROTOCOLS_DIR})
else()
    find_package(PlasmaWaylandProtocols 1.9.0 CONFIG)
    set_package_properties(PlasmaWaylandProtocols PROPERTIES
        TYPE REQUIRED
        PURPOSE "Collection of Plasma-specific Wayland protocols"
        URL "https://invent.kde.org/libraries/plasma-wayland-protocols/"
    )
endif()

if (QT_MAJOR_VERSION EQUAL "5")
    find_package(QtWaylandScanner)
    set_package_properties(QtWaylandScanner PROPERTIES
        TYPE REQUIRED
        PURPOSE "Required for building KWin with Wayland support"
    )
endif()

find_package(XKB 0.7.0)
set_package_properties(XKB PROPERTIES
    TYPE REQUIRED
    PURPOSE "Required for building KWin with Wayland support"
)
if (XKB_VERSION VERSION_GREATER_EQUAL 1.5.0)
    set(HAVE_XKBCOMMON_NO_SECURE_GETENV 1)
else()
    set(HAVE_XKBCOMMON_NO_SECURE_GETENV 0)
endif()

pkg_check_modules(XKBX11 IMPORTED_TARGET xkbcommon-x11 REQUIRED)
pkg_check_modules(XRES REQUIRED IMPORTED_TARGET xcb-res)
add_feature_info(XKBX11 XKBX11_FOUND "Required for handling keyboard events in X11 backend")

find_package(Libinput 1.12)
set_package_properties(Libinput PROPERTIES TYPE REQUIRED PURPOSE "Required for input handling on Wayland.")
try_compile(USE_GESTURE_HOLD
        ${CMAKE_CURRENT_BINARY_DIR}/try_compile
    SOURCES
        ${CMAKE_CURRENT_SOURCE_DIR}/tests/libinput_test.cc
    LINK_LIBRARIES
        Libinput::Libinput
)

if(USE_GESTURE_HOLD)
  add_definitions(-DSUPPORT_GESTURE_HOLD)
endif()

find_package(UDev)
set_package_properties(UDev PROPERTIES
    URL "https://www.freedesktop.org/wiki/Software/systemd/"
    DESCRIPTION "Linux device library."
    TYPE REQUIRED
    PURPOSE "Required for input handling on Wayland."
)

find_package(Libdrm 2.4.99)
set_package_properties(Libdrm PROPERTIES TYPE REQUIRED PURPOSE "Required for drm output on Wayland.")

find_package(gbm)
set_package_properties(gbm PROPERTIES TYPE REQUIRED PURPOSE "Required for egl output of drm backend.")
if (${gbm_VERSION} GREATER_EQUAL 21.1)
    set(HAVE_GBM_BO_GET_FD_FOR_PLANE 1)
else()
    set(HAVE_GBM_BO_GET_FD_FOR_PLANE 0)
endif()
if (${gbm_VERSION} GREATER_EQUAL 21.3)
    set(HAVE_GBM_BO_CREATE_WITH_MODIFIERS2 1)
else()
    set(HAVE_GBM_BO_CREATE_WITH_MODIFIERS2 0)
endif()

try_compile(USE_FULL_GBM
        ${CMAKE_CURRENT_BINARY_DIR}/try_compile
    SOURCES
        ${CMAKE_CURRENT_SOURCE_DIR}/tests/gbm_test.cc
    LINK_LIBRARIES
        gbm::gbm
)

if(USE_FULL_GBM)
#  add_definitions(-DSUPPORT_FULL_GBM)
endif()

try_compile(USE_DRM_TYPENAME
        ${CMAKE_CURRENT_BINARY_DIR}/try_compile
    SOURCES
        ${CMAKE_CURRENT_SOURCE_DIR}/tests/drm_test.cc
    LINK_LIBRARIES
        Libdrm::Libdrm
)

if(USE_DRM_TYPENAME)
  add_definitions(-DSUPPORT_DRM_TYPENAME)
endif()

try_compile(USE_DRM_ITERATOR
        ${CMAKE_CURRENT_BINARY_DIR}/try_compile
    SOURCES
        ${CMAKE_CURRENT_SOURCE_DIR}/tests/drm_iterator_test.cc
    LINK_LIBRARIES
        Libdrm::Libdrm
)

if(USE_DRM_ITERATOR)
  add_definitions(-DSUPPORT_DRM_ITERATOR)
endif()

pkg_check_modules(Libxcvt IMPORTED_TARGET libxcvt>=0.1.1 REQUIRED)
add_feature_info(Libxcvt Libxcvt_FOUND "Required for generating modes in the drm backend")

find_package(X11)
set_package_properties(X11 PROPERTIES
    DESCRIPTION "X11 libraries"
    URL "https://www.x.org"
    TYPE REQUIRED
)
add_feature_info("XInput" X11_Xi_FOUND "Required for poll-free mouse cursor updates")
set(HAVE_X11_XINPUT ${X11_Xinput_FOUND})

find_package(lcms2)
set_package_properties(lcms2 PROPERTIES
    DESCRIPTION "Small-footprint color management engine"
    URL "http://www.littlecms.com"
    TYPE REQUIRED
    PURPOSE "Required for the color management system"
)

# All the required XCB components
find_package(XCB 1.10 REQUIRED COMPONENTS
    COMPOSITE
    CURSOR
    DAMAGE
    GLX
