=== src/utils/CMakeLists.txt ===
target_sources(kwin PRIVATE
    abstract_opengl_context_attribute_builder.cpp
    common.cpp
    edid.cpp
    egl_context_attribute_builder.cpp
    filedescriptor.cpp
    ramfile.cpp
    realtime.cpp
    subsurfacemonitor.cpp
    udev.cpp
    xcbutils.cpp
    xcursortheme.cpp
    logutils.cpp
)
